Class | PhusionPassenger::SpawnManager
In: | lib/phusion_passenger/spawn_manager.rb
Parent: | AbstractServer

The spawn manager is capable of spawning Ruby on Rails or Rack application instances. It acts like a simple fascade for the rest of the spawn manager system.

Note: SpawnManager may only be started synchronously with AbstractServer#start_synchronously. Starting asynchronously has not been tested. Don‘t forget to call cleanup after the server‘s main loop has finished.

## Ruby on Rails optimizations

Spawning a Ruby on Rails application is usually slow. But SpawnManager will preload and cache Ruby on Rails frameworks, as well as application code, so subsequent spawns will be very fast.

Internally, SpawnManager uses ClassicRails::FrameworkSpawner to preload and cache Ruby on Rails frameworks. ClassicRails::FrameworkSpawner, in turn, uses ClassicRails::ApplicationSpawner to preload and cache application code.

In case you‘re wondering why the namespace is "ClassicRails" and not "Rails": it‘s to work around an obscure bug in ActiveSupport‘s Dispatcher.

### Methods

cleanup new reload spawn_application

### Included Modules

Utils

### Public Class methods

new(options = {})

### Public Instance methods

cleanup()

Cleanup resources. Should be called when this SpawnManager is no longer needed.

reload(app_group_name = nil)

Remove the cached application instances at the given group name. If nil is specified as group name, then all cached application instances will be removed, no matter the group name.

Long description: Application code might be cached in memory. But once it a while, it will be necessary to reload the code for an application, such as after deploying a new version of the application. This method makes sure that any cached application code is removed, so that the next time an application instance is spawned, the application code will be freshly loaded into memory.

Raises AbstractServer::SpawnError if something went wrong.

spawn_application(options)

Spawns an application with the given spawn options. When successful, an AppProcess object will be returned, which represents the spawned application process.

Most options are explained in PoolOptions.h.

Mandatory options:

- ‘app_root‘

Optional options:

- ‘app_type‘
- ‘environment‘
- ‘spawn_method‘
- ‘user’,
- ‘group‘
- ‘default_user‘
- ‘default_group‘
- ‘framework_spawner_timeout‘
- ‘app_spawner_timeout‘
- ‘environment_variables’: Environment variables which should be passed to the spawned application process. This is NULL-seperated string of key-value pairs, encoded in base64. The last byte in the unencoded data must be a NULL.
- ‘base_uri‘
- ‘print_exceptions‘

Exceptions:

- InvalidPath: `app_root` doesn‘t appear to be a valid Ruby on Rails application root.
- VersionNotFound: The Ruby on Rails framework version that the given application requires is not installed.
- AbstractServer::ServerError: One of the server processes exited unexpectedly.
- FrameworkInitError: The Ruby on Rails framework that the application requires could not be loaded.
- AppInitError: The application raised an exception or called exit() during startup.

[Validate]